/*
 * See the dyninst/COPYRIGHT file for copyright information.
 *
 * We provide the Paradyn Tools (below described as "Paradyn")
 * on an AS IS basis, and do not warrant its validity or performance.
 * We reserve the right to update, modify, or discontinue this
 * software at any time.  We shall have no obligation to supply such
 * updates or modifications or any other form of support to you.
 *
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* $Id: ELF_Section.h,v 1.6 2005/02/24 10:15:39 rchen Exp $ */

/* ccw 21 nov 2001 */

#if defined(i386_unknown_linux2_0) ||                                                    \
    defined(x86_64_unknown_linux2_4) /* Blind duplication - Ray */

#    ifndef ELF_Section__
#        define ELF_Section__
typedef struct
{
    unsigned int vaddr;
    void*        data;
    unsigned int dataSize;
    Elf32_Shdr*  shdr;
    char*        name;
    int          nameIndx;
    unsigned int align;
    unsigned int flags;
    unsigned int type;
    bool         loadable;
} ELF_Section;
// make this a class w/desctuctor

typedef struct
{
    Elf32_Sword d_tag;
    union
    {
        Elf32_Sword d_val;
        Elf32_Addr  d_ptr;
    } d_un;
} __Elf32_Dyn;

#        define DT_NULL 0
#        define DT_NEEDED 1
#        define DT_STRTAB 5
#        define DT_PLTREL 20
#        define DT_PLTGOT 3
#        define DT_HASH 4
#        define DT_SYMTAB 6
#        define DT_RELA 7
#        define DT_INIT 12
#        define DT_FINI 13
#        define DT_REL 17
#        define DT_VERDEF 0x6ffffffc
#        define DT_VERDEFNUM 0x6ffffffd
#        define DT_VERNEED 0x6ffffffe
#        define DT_VERNEEDNUM 0x6fffffff
#        define DT_JMPREL 23
#        define DT_STRSZ 10
#        define DT_CHECKSUM 0x6ffffdf8
#        define DT_DEBUG 21

#    endif
#endif
